
/***********************************************************  EST1    *******************************************************/
/******************************************************************************
   Nom:                 SP_ALTA_EST1
   Propsit:            Fa el clcul de totes les descrregues fetes i si s el primer valor calculat, l'afegeix  a la taula EST1
                        i si no s el primer, l'afegeix a EST1 havent esborrat abans l'antic valor de la taula. Aix doncs, en la taula 
                        sempre i haur un nic valor: el total de descrregues fetes.
   Parmetres entrada:  Sense parmetres           

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/

Create or replace PROCEDURE SP_ALTA_EST1

IS

--variables

param_entrada VARCHAR2(500);
totalDesc     INTEGER;
comptador     INTEGER;
RSP           VARCHAR2(500);
error_msg     VARCHAR2(500);


BEGIN
   param_entrada:='Sense parmetres';

-- calculem les descrregues fetes i el total de files inserides en la taula EST1

   SELECT COUNT(*) INTO totalDesc FROM DESCARREGA;
   SELECT COUNT(*) INTO comptador FROM EST1;

-- si la taula EST1 est buida afegim el valor del total de descrregues que s'han fet i si no est buida
-- esborrem l'ltim valor de la taula EST1 i afegim el nou valor (que ser l'antic +1)

   IF(comptador=0) THEN
   
   INSERT INTO EST1(totalDescarregues) VALUES (totaldesc);

   ELSE

    SELECT totalDescarregues INTO comptador FROM EST1;
    DELETE FROM EST1 WHERE totalDescarregues=comptador;
    INSERT INTO EST1(totalDescarregues) VALUES (totalDesc);

   END IF;

--  inserci correcta
   
    RSP:='OK';
    SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST1', param_entrada, 'RSP: '||RSP);
  


COMMIT;

EXCEPTION
 
 WHEN OTHERS THEN
      ROLLBACK;

         error_msg:=SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR: '||error_msg;
         SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST1', param_entrada, 'RSP: '||RSP);
         DBMS_OUTPUT.PUT_LINE(RSP);


END SP_ALTA_EST1;
