/*************************************************************** EST2  *****************************************************************************************/
/******************************************************************************
   Nom:                 SP_ALTA_EST2
   Propsit:            Calcula el total d'euros generats per la plataforma en descrregues fins el moment
                        del clcul. Afegeix aquest nombre a la taula EST2 si la taula est buida i sin, esborra
                        l'antic valor de EST2 i afegeix el nou valor: per tant, sempre hi haur un nic valor
                        que ser el total d'euros generats per la plataforma.
                   
   Parmetres entrada:  Sense parmetres            

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/

Create or replace PROCEDURE SP_ALTA_EST2

IS

--variables

param_entrada VARCHAR2(500);
comptador     INTEGER;


SUMA            INTEGER:=0;
PRICE           NUMBER;
RSP             VARCHAR2(500);
error_msg       VARCHAR2(500);
TYPE REFCURSOR  IS REF CURSOR;
CUR REFCURSOR;


BEGIN

  param_entrada:='Sense parmetres';

--obrim un cursor amb tots els preus de cada pas de cada aplicaci descarregada. S'itera sumant cada preu per obtenir el total de euros recaudats

  OPEN CUR FOR SELECT R.PREU  FROM REGISTRE R,DESCARREGA DE,APLICACIO AP WHERE R.PAIS=DE.PAIS AND AP.IDENTIFICADOR=DE.APLICACIO AND
  AP.IDENTIFICADOR=R.APLICACIO;
  LOOP
   
    FETCH CUR INTO PRICE;
    EXIT WHEN CUR%NOTFOUND;
 
    suma:=suma+price;

  END LOOP;
  CLOSE CUR;

-- anem modificant el valor de la taula EST2 per cada descrrega. Esborrem el valor antic de la taula EST2 i inserim la nova suma.

  SELECT COUNT(*) INTO comptador FROM EST2;

  IF(comptador=0) THEN

     INSERT INTO EST2(totalEuros) VALUES (suma);

  ELSE
   
     SELECT totalEuros INTO comptador FROM EST2;
     DELETE FROM EST2 WHERE totalEuros=comptador;
     INSERT INTO EST2(totalEuros) VALUES (suma);
    
  END IF;

--  inserci correcta

    RSP:='OK';
    SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST2', param_entrada, 'RSP: '||RSP);
  


COMMIT;

EXCEPTION

 WHEN OTHERS THEN
      ROLLBACK;

         error_msg:=SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR: '||error_msg;
         SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST2', param_entrada, 'RSP: '||RSP);
         DBMS_OUTPUT.PUT_LINE(RSP);


END SP_ALTA_EST2;