/*******************************************************************  EST7   ************************************************************************/
/******************************************************************************
   Nom:                 SP_ALTA_EST7
   Propsit:            Donat una any i un pas passats com a parmetre d'entrada retorna els ingressos que han generat els usuaris d'aquell
                        pas en aquell any en descrregues d'aplicacions. 
                   
   Parmetres entrada:  p_any,p_pais            

   Retorna:             'OK' si l'execuci ha finalitzat amb xit
                        'ERROR: tipus d'error' si ha fracassat
******************************************************************************/
create or replace PROCEDURE SP_ALTA_EST7(
        p_any        IN EST7.ao%TYPE,
        p_pais       IN EST7.pais%TYPE
  )

IS

--variables

param_entrada   VARCHAR2(50);
error_msg       VARCHAR2(100);
RSP             VARCHAR2(200);
valor_nul       VARCHAR2(30);
comptador       INTEGER;
suma            INTEGER;
E_NUL           EXCEPTION;

-- emmagatzemem en el cursor l'any, el pas de descrrega i la suma d'ingresos per aquell pas i any

CURSOR CUR IS SELECT EXTRACT(year from de.dataDesc),de.pais,SUM(r.preu) FROM DESCARREGA de,APLICACIO ap,REGISTRE r WHERE r.pais=p_pais AND
              de.pais=p_pais AND extract(year from de.datadesc)=p_any AND de.aplicacio=ap.identificador AND ap.identificador=r.aplicacio
              GROUP BY de.pais,EXTRACT(year from de.dataDesc);

country        CHAR(2);
anyo           NUMBER;
total          NUMBER;


BEGIN

   param_entrada:=    'Any: '||p_any||
                      ', Pais: '||p_pais;

--controlem que els parmetres d'entrada no siguin nuls

  IF (p_any IS NULL) THEN
     valor_nul:='any';
     RAISE E_NUL;
  ELSIF (p_pais IS NULL) THEN
     valor_nul:='pais';
     RAISE E_NUL;
  END IF;

--es van inserint en la taula EST7 de manera que no hi hagi registre repetits amb el mxim nombre d'ingressos.

    OPEN CUR;
       LOOP
         FETCH CUR INTO anyo,country,total;
         EXIT WHEN CUR%NOTFOUND;
         SELECT COUNT(*) INTO comptador FROM EST7 WHERE p_pais=pais AND ao=p_any AND total=ingressos;
         IF(comptador=0) THEN
            INSERT INTO EST7(ao,pais,ingressos) VALUES (p_any,p_pais,total);
         END IF;
       
       END LOOP;
     CLOSE CUR;
       
-- esborrem de la taula tots aquells registres que no tinguin el major nombre d'ingressos per a l'any i pas donat.

       SELECT MAX(ingressos) INTO total FROM est7 WHERE pais=p_pais AND ao=p_any;
       DELETE FROM EST7 WHERE ingressos<>total AND ao=p_any AND pais=p_pais;
     

--execuci correcta

         RSP:= 'OK';
         SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST7', param_entrada, 'RSP: '||RSP); 
        



EXCEPTION

 WHEN E_NUL THEN
         RSP:= 'ERROR: el valor '||valor_nul||' any no pot estar buit';
         SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST7', param_entrada, 'RSP: '||RSP);
         DBMS_OUTPUT.PUT_LINE(RSP);

 WHEN OTHERS THEN
      ROLLBACK;

         error_msg:=SUBSTR(SQLERRM, 1, 200);
         RSP:= 'ERROR: '||error_msg;
         SP_ALTA_LOGS(to_char(sysdate,'DD/MM/YYYY HH24:MI:SS'), 'EST7', param_entrada, 'RSP: '||RSP);
         DBMS_OUTPUT.PUT_LINE(RSP);


END SP_ALTA_EST7;
