SET serveroutput on;
spool PROVES.log
set echo on


-- TRACTAMENT D'ERRORS DELS PROCEDIMENTS ABM I SORTIDA DE LES CONSULTES DEL MDUL ESTADSTIC



/**************************************************** ABM USUARIS  ******************************************************/
DECLARE 
rsp VARCHAR2(500);
BEGIN
-- valors null
SP_ALTA_USUARI('11100001A', 666045001, NULL, 'ES', 'orange',RSP);
--telefon repetit
SP_ALTA_USUARI('12300001A', 666000001, 'lonji@yahoo.es', 'ES', 'orange',RSP);
--usuari repetit
SP_ALTA_USUARI('00000001A', 666088001, 'mairi@hotmail.com', 'ES', 'orange',RSP);
--insercio correcta
SP_ALTA_USUARI('11111111A',666999777,'liunyt@gmail.com','AD','Mobiland',RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
--baixa correcta
SP_BAIXA_USUARI('11111111A',RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
--usuari per donar de baixa no existeix
SP_BAIXA_USUARI('XX123411A',RSP);
--modificacio incorrecta: el telfon ja existeix en la bases de dades
SP_MODIFICACIO_USUARI('00000001B',666000001,'JJTTEE@yahoo.es','ES','Euskatel',RSP);
--modificacio incorrecta: l'usuari no existei
SP_MODIFICACIO_USUARI('00090001A',666000001,'JJTTEE@yahoo.es','ES','Euskatel',RSP);
--modificacio correcta
SP_MODIFICACIO_USUARI('00000001A',666110002,'JJTTEE@yahoo.es','ES','Euskatel',RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/

/**************************************************** ABM DESENVOLUPADORS **************************************************/
DECLARE
RSP  VARCHAR2(500);
BEGIN
-- valors null
SP_ALTA_DESENVOLUPADOR('10320000A',699097001,'wilt@orange.es', NULL, '11/07/89','Cadiz',RSP);
-- el desenvolupador ja existeix
SP_ALTA_DESENVOLUPADOR('10000000A',699003331,'wilt@orange.es', 'ES', '11/11/1990','Cadiz',RSP);
-- el telefon ja existeix
SP_ALTA_DESENVOLUPADOR('12220000A',699000001,'wilt@orange.es', 'ES', '11/11/1990','Cadiz',RSP);
--alta correcta
SP_ALTA_DESENVOLUPADOR('12345600A',688888001,'wilt@orange.es', 'ES', '11/11/1990','Cadiz',RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
-- baixa correcta
SP_BAIXA_DESENVOLUPADOR('12345600A',RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
--modificacio amb valors null
SP_MODIFICACIO_DESENVOLUPADOR('10000000A',699000001,NULL, 'ES', '11/11/1990','Cadiz',RSP);
-- modificaci amb un telfon que ja existia
SP_MODIFICACIO_DESENVOLUPADOR('10000000A',699000017,'wilt@orange.es', 'ES', '11/11/1990','Cadiz',RSP);
--modificaci de un desenvolupador que no existeix
SP_MODIFICACIO_DESENVOLUPADOR('X0123450A',699000001,'wilt@orange.es', 'ES', '11/11/1990','Cadiz',RSP);
--modificacio correcta
SP_MODIFICACIO_DESENVOLUPADOR('10000000A',699440001,'wilt@orange.es', 'ES', '11/11/1990','Tarragona',RSP);
DBMS_OUTPUT.PUT_LINE(RSP);


END;
/
/*************************************************** ABM APLICACIONS *******************************************/
DECLARE
RSP   VARCHAR2(500);
BEGIN

-- no pot tenir valors null
SP_ALTA_APLICACIO(23,'V1.0a',NULL,'http://www.video1.com','SI',22,RSP);
-- no es poden repetir identificador d'aplicacions (claus primries)
SP_ALTA_APLICACIO(1,'V1.0a','11/12/10','http://www.video1.com','SI',22,RSP);
-- la data d'inserci de la aplicaci no pot ser superior a l'actual
SP_ALTA_APLICACIO(50,'V1.9a','11/12/14','http://www.video50.com','SI',32,RSP);
-- el valor de l'atribut activa ha de se SI   NO
SP_ALTA_APLICACIO(50,'V1.9a','11/12/11','http://www.video50.com','RT',32,RSP);
--alta correcta
SP_ALTA_APLICACIO(22,'V3.0a','11/11/12','http://www.video23.com','SI',22,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

--baixa correcta
SP_BAIXA_APLICACIO(22,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

-- baixa d'una aplicaci que no existeix
SP_BAIXA_APLICACIO(33,RSP);
--modificacio amb valors null
SP_MODIFICACIO_APLICACIO(1,'V1.0a',NULL,'http://www.video1.com','SI',22,RSP);
-- modificacio d'una aplicaci que no existeix
SP_MODIFICACIO_APLICACIO(90,'V1.0a','11/12/10','http://www.video1.com','SI',22,RSP);
--modificacio correcta
SP_MODIFICACIO_APLICACIO(1,'V1.1h','11/12/10','http://www.video1.com','SI',18,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);


END;
/
/************************************************* ALTA DESCRREGUES ********************************************/
DECLARE
RSP VARCHAR2(500);
BEGIN
-- valors null
SP_DESCARREGA('00000001N',1,'13/11/10',NULL,'movistar','ES',1111111111111,RSP);
-- aplicacio no existeix
SP_DESCARREGA('00000001A',40,'13/11/10','paypal','movistar','ES',1111111111111,RSP);
--usuari no existeix
SP_DESCARREGA('02320001A',1,'13/11/10','paypal','movistar','ES',1111111111111,RSP);
--dispositiu no existeix
SP_DESCARREGA('00000001A',1,'13/11/10','paypal','movistar','ES',0001111111111,RSP);
-- la data de descarrega no pot ser major a l'actual
SP_DESCARREGA('00000001A',1,'13/11/14','paypal','movistar','ES',1111111111114,RSP);
--la resoluci del dispositiu ha de ser major que la suportada per l'aplicaci
SP_DESCARREGA('00000001A',15,'13/11/10','paypal','movistar','ES',1111111111115,RSP);


END;
/
/************************************************** CONSULTES  *****************************************************/


--CONSULTA 1



-- fem la consulta1 sobre el pas EEUU 'US'
select * from table(DESENV_NOMBRE_APLICACIONS('US'));
/
--fem la consulta1 sobre el pas Gran Bretanya GB
select * from table(DESENV_NOMBRE_APLICACIONS('GB'));
/
-- fem la consulta1 sobre el pas Espanya ES
select * from table(DESENV_NOMBRE_APLICACIONS('ES'));
/


-- CONSULTA 2 



--fem la consulta 
select * from table(APLICACIONS_ACTIVES);
/
--afegim una nova aplicaci
DECLARE
RSP VARCHAR2(500);
BEGIN
SP_ALTA_APLICACIO(22,'V3.0a','12/08/12','http://www.video22.com','SI',9.9,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--tornem a fer la consulta i observem els canvis
select * from table(APLICACIONS_ACTIVES);

/



-- CONSULTA 3



--fem la consulta per l'aplicaci 1 i l'any 2010
select * from table(PAISOS_NOMBRE_DESCARREGUES(1,2010));

--afegim una descrrega de l'aplicaci 1 en l'any 2010
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('X0000001J',1,'11/11/10','Visa','movistar','US',1111111111181,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--tornem a fer la consulta i observem els canvis
select * from table(PAISOS_NOMBRE_DESCARREGUES(1,2010));
/



-- CONSULTA 4



--fem una consulta per l'usuari amb aquest nmero de telfon
select * from table(ACTIVITAT_USUARI(666000801));
/
--afegim una altra descrrega per aquest usuari
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('00000001S',6,'11/11/10','MoneyTransfer','Movistar','US',1111111111151,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--tornem a executar la consulta4 sobre el mateix usuari
select * from table(ACTIVITAT_USUARI(666000801));
/



--CONSULTA 5 



select * from table(MAX_DESPESA(2010));
/
select * from table(MAX_DESPESA(2011));
/
select * from table(MAX_DESPESA(2012));

/
-- CONSULTA 6



select * from table(SO_MES_UTILITZATS(2010));
/
select * from table(SO_MES_UTILITZATS(2011));
/
select * from table(SO_MES_UTILITZATS(2012));



/************************************** ESTADSTIQUES ****************************************************/


-- ESTADSTICA 1 ----------------retorna el nombre total de descrregues en la plataforma


SELECT * FROM EST1;
/
-- afegim una descrrega
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('X0000001J',3,'11/11/10','Paypal','movistar','US',1111111111181,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--tornem a fer la consulta
SELECT * FROM EST1;
/


-- ESTADSTICA 2 -----------------retorna el nombre total d'euros generats en la plataforma fins el moment de la consulta

SELECT * FROM EST2;
/
--afegim una altra descarrega de preu en AD:180
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('X0000001J',5,'13/11/10','Visa','movistar','AD',1111111111181,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--tornem a fer la consulta
SELECT * FROM EST2;
/



-- ESTADSTICA 3   -------------- retorna, per un any donat, el nombre mig de aplicacions descarregades per un usari. s a dir el total d'aplicacions descarregades
-- en un any dividit pel total d'usuaris diferents que han fet descarregues aquell any    RET=SUM(aplicacions)/usuaris_diferents


SELECT * FROM EST3 WHERE ao='2012';
/
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('X0000001J',2,'13/11/12','Visa','movistar','AD',1111111111181,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--tornem a executar la consulta per al mateix any i observem la variaci
SELECT * FROM EST3 WHERE ao='2012';
/
--fem les consultes per altres anys
SELECT * FROM EST3 WHERE ao='2011';
/
SELECT * FROM EST3 WHERE ao='2010';
/




--ESTADSTICA 4 --------------------- retorna, en per un any donat, el desenvolupador o desenvolupadors del qual s'han fet ms descarregues junt amb aquest nombre


--fem la consulta per un any
SELECT * FROM EST4 WHERE ao='2010';
/
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('X0000001J',8,'13/11/10','Visa','movistar','AD',1111111111181,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);

END;
/
--repetim la consulta i observem els canvis
SELECT * FROM EST4 WHERE ao='2010';
/ 
--fem la consulta per d'altres anys
SELECT * FROM EST4 WHERE ao='2011';
/
SELECT * FROM EST4 WHERE ao='2012';
/



-- ESTADSTICA 5 -----------------  retorna, per un any donat, l'aplicaci o aplicacions (en cas d'empat) que ms ha recaudat i els desenvolupadors que l'han creat

--fem una consulta per un any
SELECT * FROM EST5 WHERE ao='2010';
/
--afegim una nova descrrega de l'aplicaci 9 
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('00000001Z',9,'13/12/10','Visa','Movistar','AD',1111111111198,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
--tornem a fer la consulta i observem els canvis i observem que passen a ser dues apps.
SELECT * FROM EST5 WHERE ao='2010';
/
--fem consultes per altres anys
SELECT * FROM EST5 WHERE ao='2011';
/
SELECT * FROM EST5 WHERE ao='2012';
/


-- ESTADSTICA 6 --------- donats un pas i un any retorna els usuaris diferents que han fet almenys una descrrega

-- fem la consulta per l'any 2010 i el pas ES
SELECT * FROM EST6 WHERE ao='2010' AND pais='ES';
/
--fem una nova descrrega per aquest any i pas i un usuari diferent
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('00000001Y',20,'13/12/10','Visa','Movistar','ES',1111111111197,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
--tornem a fer la consulta
SELECT * FROM EST6 WHERE ao='2010' AND pais='ES';
/
--fem consultes per d'altres pasos i anys
SELECT * FROM EST6 WHERE ao='2011' AND pais='US';
/
SELECT * FROM EST6 WHERE ao='2012' AND pais='AD';
/


-- ESTADSITCA 7 -------- per una any i un pas donat retorna els ingressos totals generats en apps en aquell any i pas

--fem la consulta per un any i pas
SELECT * FROM EST7 WHERE ao='2010' AND pais='AD';
/
--afegim una descrrega en aquell pas i per aquell any
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('00000001Z',2,'13/12/10','Visa','Movistar','AD',1111111111198,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
END;
/
--tornem a fer la consulta i observem els canvis
SELECT * FROM EST7 WHERE ao='2010' AND pais='AD';
/
--fem d'altres consultes per d'altres anys i pasos
SELECT * FROM EST7 WHERE ao='2011' AND pais='ES';
/
SELECT * FROM EST7 WHERE ao='2012' AND pais='US';
/


-- ESTADSTICA 8 ----Donats un any i un pas, retorna el nombre d'aplicacions diferents descarregades com a mnim una vegada
--                    en aquell any i pas

--fem una consulta per l'any 2010 i el pas ES
SELECT * FROM EST8 WHERE pais='ES' AND ao='2010';
/
--afegim una aplicaci no descarregada en aquell any
DECLARE
RSP VARCHAR2(500);
BEGIN 
SP_DESCARREGA('00000001Z',8,'13/07/10','Visa','Movistar','ES',1111111111198,RSP);
DBMS_OUTPUT.PUT_LINE(RSP);
END;
/

--tornem a fer la consulta
SELECT * FROM EST8 WHERE ao='2010' AND pais='ES';
/

--fem consultes per d'altres anys i pasos
SELECT * FROM EST8 WHERE ao='2011' AND pais='US';
/
SELECT * FROM EST8 WHERE ao='2012' AND pais='GB';
/

/******************************** LOGS  ***************************************************/

-- EXECUTEM LA CONSULTA A LA TAULA LOGS
SELECT * FROM LOGS ORDER BY 1 DESC;
/


spool off
exit